<template>
  <div>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="gettingStoreData"/>
    <v-flex v-if="showStoreInfo">
      <v-card id="loginContentContainer"
        class="defaultCardBackground"
        style="margin:0 auto;">
        <v-toolbar light flat style="background:transparent">
          <v-card-title>
            <h4 style="color:rgb(80, 130, 150)">
              Stores
            </h4>
          </v-card-title>
          <v-spacer></v-spacer>
          <v-btn
            color="darkSecondary"
            class="white--text"
            depressed
            @click.native="onAddStoreClick">
            ADD STORE
          </v-btn>
        </v-toolbar>
        <v-divider></v-divider>
        <div class="noStoresFoundMessage"
          v-if="noStoresFound">
          No stores found
        </div>
        <v-list v-for="store in allStoresList"
          :key="store"
          style="background:transparent">
          <v-list-tile style="background:transparent">
            {{store}}
            <v-spacer></v-spacer>
            <v-btn icon
              @click.native.stop="onEditStoreClick(store)">
              <v-icon color="primary">
                edit
              </v-icon>
            </v-btn>
            <v-btn icon
              @click.native.stop="onDeleteStoreClick(store)">
              <v-icon color="primary">
                delete
              </v-icon>
            </v-btn>
          </v-list-tile>
          <v-divider></v-divider>
        </v-list>
      </v-card>
      <v-dialog v-model="deleteDialog"
        max-width="400">
        <v-card style="background:white">
          <v-progress-linear
            v-if="deleteRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="#ff0000"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
        <v-card-title style="color:#4f8196">
          <h4>
            Are you shure you want to delete store {{storeToBeDeleterOrEdited}}?
          </h4>
        </v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="darkSecondary"
            depressed
            dark
            @click.native="deleteDialog = false">
            CANCEL
          </v-btn>
          <v-btn outline
            color="error"
            @click="onSubmitDeleterStoreClick">
            DELETE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog v-model="editDialog"
      max-width="400"
      style="background:white">
      <v-card style="background:white">
        <v-progress-linear
          v-if="editRequested"
          :indeterminate="true"
          height="4"
          color="success"
          background-color="#ff0000"
          style="height: 4px;position: absolute;top: -16px;">
        </v-progress-linear>
        <v-card-title>
          <h4 style="color:#4f8196">
            {{modalMessage}}
          </h4>
        </v-card-title>
        <v-divider></v-divider>
        <v-card-actions>
          <form style="width:97%;"
            @submit.prevent="$v.$touch(); if($v.$error === false){onSubmitEditOrAddStoreClick()};">
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.storeToBeDeleterOrEdited.$error }">
              <input id="storeToBeDeleterOrEdited"
                class="inputDefault"
                type="text"
                v-model.trim="storeToBeDeleterOrEdited"
                @input="$v.storeToBeDeleterOrEdited.$touch()"
                v-on:input="$v.storeToBeDeleterOrEdited.$touch"
                v-bind:class="{
                  error: $v.storeToBeDeleterOrEdited.$error,
                  valid: $v.storeToBeDeleterOrEdited.$dirty && !$v.storeToBeDeleterOrEdited.$invalid
                }"/>
              <label for="storeToBeDeleterOrEdited"
                class="defaultInputPlaceholder">
                Store name
              </label>
              <span class="formErrorMessage"
                v-if="$v.storeToBeDeleterOrEdited.$error && $v.storeToBeDeleterOrEdited.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.storeToBeDeleterOrEdited.$dirty && !$v.storeToBeDeleterOrEdited.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.storeToBeDeleterOrEdited.$error && $v.storeToBeDeleterOrEdited.$dirty">
                cancel
              </v-icon>
            </div>
            <v-btn color="darkSecondary"
              depressed
              dark
              type="submit"
              style="float:right;margin-right:10%;">
              {{submitMessage}}
            </v-btn>
          </form>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-flex>
  </div>
</template>
<script>
import axios from 'axios'
import DefaultSpinnerComponent from './../common/spinner.vue'
import { required } from 'vuelidate/lib/validators'
export default {
  name: 'StoreComponent',
  components: {
    DefaultSpinnerComponent
  },
  data: () => ({
    allStoresList: [],
    gettingStoreData: false,
    showStoreInfo: true,
    submitRequested: true,
    loadingMessage: 'Loading store data',
    deleteDialog: false,
    editDialog: false,
    storeToBeDeleterOrEdited: '',
    deleteRequested: false,
    editRequested: false,
    originalStoreName: '',
    noStoresFound: false,
    modalMessage: '',
    operation: undefined,
    submitMessage: ''
  }),
  methods: {
    onAddStoreClick () {
      this.modalMessage = 'Add store'
      this.editDialog = true
      this.storeToBeDeleterOrEdited = undefined
      this.operation = 'ADD'
      this.submitMessage = 'ADD STORE'
    },
    onDeleteStoreClick (storeName) {
      this.storeToBeDeleterOrEdited = storeName
      this.deleteDialog = true
    },
    onEditStoreClick (storeName) {
      this.storeToBeDeleterOrEdited = storeName
      this.originalStoreName = storeName
      this.modalMessage = 'Edit store'
      this.editDialog = true
      this.operation = 'EDIT'
      this.submitMessage = 'EDIT STORE'
    },
    onSubmitDeleterStoreClick () {
      this.deleteRequested = true
      axios.delete('store/' + this.storeToBeDeleterOrEdited)
        .then(response => {
          setTimeout(() => {
            this.deleteRequested = false
            this.deleteDialog = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Store ' + this.storeToBeDeleterOrEdited + ' is deleted succefully')
          }, 2000)
        })
        .catch(error => {
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured while deleting store : ' + error)
        })
    },
    onSubmitEditOrAddStoreClick () {
      this.editRequested = true
      if (this.operation === 'ADD') {
        axios.post('store', {
          storeName: this.storeToBeDeleterOrEdited
        })
          .then(response => {
            setTimeout(() => {
              this.editRequested = false
              this.editDialog = false
              this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Store ' + this.originalStoreName + ' is added succefully')
            }, 2000)
          })
          .catch(error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured while adding store : ' + error)
          })
      } else if (this.operation === 'EDIT') {
        axios.put('store/' + this.originalStoreName, {
          storeName: this.storeToBeDeleterOrEdited
        })
          .then(response => {
            setTimeout(() => {
              this.editRequested = false
              this.editDialog = false
              this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'Store ' + this.originalStoreName + ' is updated succefully')
            }, 2000)
          })
          .catch(error => {
            this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured while updating store : ' + error)
          })
      }
    }
  },
  created () {
    axios.get('store')
      .then(response => {
        this.allStoresList = response.data
        response.data.length === 0 ? this.noStoresFound = true : this.noStoresFound = false
      })
      .catch(error => {
        this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error in getting all stores list: ' + error)
      })
  },
  validations: {
    storeToBeDeleterOrEdited: {
      required
    }
  }
}
</script>
<style scoped>
.error {
  border: 1px solid #FF3D00 !important;
  background: #ffffff !important;
}

.error:focus {
  outline-color: #F99;
}

.valid {
  border:1px solid #43A047 !important;
}

.valid:focus {
  outline-color: #43A047;
}
.formErrorMessage{
  color: #FF3D00;
  font-size: 14px;
  font-family: Roboto;
  position: absolute;
  left: 10px;
  bottom: -10px;
}

.login{
  padding-top: 1px;
}
#loginContentContainer{
  width: 35%;
  display: block;
  margin: 0 ;
  height: auto;
  min-height: 300px;
  padding-bottom: 30px;
}
.loginContainer{
  background: #eeeeee !important;
  margin-top: 10vh;
}
.loginText{
  background: #F5F5F5;
  border: 1px solid #4D4D4D;
  border-radius: 4px;
  padding: 12px;
}
.ellaText{
  color: #a53a00;
}
.noStoresFoundMessage{
  font-size: 50px;
  color: #9E9E9E;
  text-align: center;
  margin-top: 50px;
}
@media only screen and (max-width: 1150px){
  #loginContentContainer{
    width: 50% !important;
  }
}
@media only screen and (max-width: 800px){
  #loginContentContainer{
    width: 70% !important;
  }
}
@media only screen and (max-width: 550px){
  #loginContentContainer{
    width: 80% !important;
  }
}
@media only screen and (max-width: 480px){
  #loginContentContainer{
    width: 96% !important;
  }
}
</style>
